diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/timer-impl.h ns-3.42/src/core/model/timer-impl.h
--- ns-3.41/src/core/model/timer-impl.h	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/timer-impl.h	2024-05-29 15:29:46.936073000 -0700
@@ -1080,109 +188,21 @@
  *  Implementation of TimerImpl itself.
  ********************************************************************/
 
-template <typename T1>
+template <typename... Args>
 void
-TimerImpl::SetArgs(T1 a1)
+TimerImpl::SetArgs(Args... args)
 {
-    typedef TimerImplOne<typename TimerTraits<T1>::ParameterType> TimerImplBase;
+    using TimerImplBase = TimerImplX<const std::remove_cvref_t<Args>&...>;
     auto impl = dynamic_cast<TimerImplBase*>(this);
     if (impl == nullptr)
     {
         NS_FATAL_ERROR("You tried to set Timer arguments incompatible with its function.");
         return;
     }
-    impl->SetArguments(a1);
+    impl->SetArguments(args...);
 }
 
-template <typename T1, typename T2>
-void
-TimerImpl::SetArgs(T1 a1, T2 a2)
-{
-    typedef TimerImplTwo<typename TimerTraits<T1>::ParameterType,
-                         typename TimerTraits<T2>::ParameterType>
-        TimerImplBase;
-    auto impl = dynamic_cast<TimerImplBase*>(this);
-    if (impl == nullptr)
-    {
-        NS_FATAL_ERROR("You tried to set Timer arguments incompatible with its function.");
-        return;
-    }
-    impl->SetArguments(a1, a2);
-}
-
-template <typename T1, typename T2, typename T3>
-void
-TimerImpl::SetArgs(T1 a1, T2 a2, T3 a3)
-{
-    typedef TimerImplThree<typename TimerTraits<T1>::ParameterType,
-                           typename TimerTraits<T2>::ParameterType,
-                           typename TimerTraits<T3>::ParameterType>
-        TimerImplBase;
-    auto impl = dynamic_cast<TimerImplBase*>(this);
-    if (impl == nullptr)
-    {
-        NS_FATAL_ERROR("You tried to set Timer arguments incompatible with its function.");
-        return;
-    }
-    impl->SetArguments(a1, a2, a3);
-}
-
-template <typename T1, typename T2, typename T3, typename T4>
-void
-TimerImpl::SetArgs(T1 a1, T2 a2, T3 a3, T4 a4)
-{
-    typedef TimerImplFour<typename TimerTraits<T1>::ParameterType,
-                          typename TimerTraits<T2>::ParameterType,
-                          typename TimerTraits<T3>::ParameterType,
-                          typename TimerTraits<T4>::ParameterType>
-        TimerImplBase;
-    auto impl = dynamic_cast<TimerImplBase*>(this);
-    if (impl == nullptr)
-    {
-        NS_FATAL_ERROR("You tried to set Timer arguments incompatible with its function.");
-        return;
-    }
-    impl->SetArguments(a1, a2, a3, a4);
-}
-
-template <typename T1, typename T2, typename T3, typename T4, typename T5>
-void
-TimerImpl::SetArgs(T1 a1, T2 a2, T3 a3, T4 a4, T5 a5)
-{
-    typedef TimerImplFive<typename TimerTraits<T1>::ParameterType,
-                          typename TimerTraits<T2>::ParameterType,
-                          typename TimerTraits<T3>::ParameterType,
-                          typename TimerTraits<T4>::ParameterType,
-                          typename TimerTraits<T5>::ParameterType>
-        TimerImplBase;
-    auto impl = dynamic_cast<TimerImplBase*>(this);
-    if (impl == nullptr)
-    {
-        NS_FATAL_ERROR("You tried to set Timer arguments incompatible with its function.");
-        return;
-    }
-    impl->SetArguments(a1, a2, a3, a4, a5);
-}
-
-template <typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-void
-TimerImpl::SetArgs(T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6)
-{
-    typedef TimerImplSix<typename TimerTraits<T1>::ParameterType,
-                         typename TimerTraits<T2>::ParameterType,
-                         typename TimerTraits<T3>::ParameterType,
-                         typename TimerTraits<T4>::ParameterType,
-                         typename TimerTraits<T5>::ParameterType,
-                         typename TimerTraits<T6>::ParameterType>
-        TimerImplBase;
-    auto impl = dynamic_cast<TimerImplBase*>(this);
-    if (impl == 0)
-    {
-        NS_FATAL_ERROR("You tried to set Timer arguments incompatible with its function.");
-        return;
-    }
-    impl->SetArguments(a1, a2, a3, a4, a5, a6);
-}
+} // namespace internal
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/trickle-timer.cc ns-3.42/src/core/model/trickle-timer.cc
--- ns-3.41/src/core/model/trickle-timer.cc	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/trickle-timer.cc	2024-05-29 15:29:46.936073000 -0700
@@ -21,6 +21,7 @@
 
 #include "log.h"
 
+#include <bit>
 #include <limits>
 
 namespace ns3
@@ -116,20 +117,7 @@
         return 0;
     }
 
-    // Here we assume that m_ticks is a power of 2.
-    // This could have been way more elegant by using
-    // std::countl_zero() defined in the <bit> header
-    // which is c++20 - so not yet widely available.
-
-    uint64_t ticks = m_ticks;
-    uint8_t doublings = 0;
-    while (ticks != 1)
-    {
-        ticks >>= 1;
-        doublings++;
-    }
-
-    return doublings;
+    return std::countr_zero(m_ticks);
 }
 
 uint16_t
@@ -144,7 +132,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_timerExpiration.IsRunning())
+    if (m_timerExpiration.IsPending())
     {
         return Simulator::GetDelayLeft(m_timerExpiration);
     }
@@ -157,7 +145,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_intervalExpiration.IsRunning())
+    if (m_intervalExpiration.IsPending())
     {
         return Simulator::GetDelayLeft(m_intervalExpiration);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/trickle-timer.h ns-3.42/src/core/model/trickle-timer.h
--- ns-3.41/src/core/model/trickle-timer.h	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/trickle-timer.h	2024-05-29 15:29:46.936073000 -0700
@@ -33,8 +33,13 @@
 namespace ns3
 {
 
+namespace internal
+{
+
 class TimerImpl;
 
+} // namespace internal
+
 /**
  * \ingroup timer
  * \brief A Trickle Timer following \RFC{6206}.
@@ -230,7 +235,7 @@
      * The timer implementation, which contains the bound callback
      * function and arguments.
      */
-    TimerImpl* m_impl;
+    internal::TimerImpl* m_impl;
 
     /** The future event scheduled to expire the timer. */
     EventId m_timerExpiration;
@@ -265,7 +270,7 @@
 TrickleTimer::SetFunction(FN fn)
 {
     delete m_impl;
-    m_impl = MakeTimerImpl(fn);
+    m_impl = internal::MakeTimerImpl(fn);
 }
 
 template <typename MEM_PTR, typename OBJ_PTR>
@@ -273,7 +278,7 @@
 TrickleTimer::SetFunction(MEM_PTR memPtr, OBJ_PTR objPtr)
 {
     delete m_impl;
-    m_impl = MakeTimerImpl(memPtr, objPtr);
+    m_impl = internal::MakeTimerImpl(memPtr, objPtr);
 }
 
 template <typename... Ts>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/type-id.cc ns-3.42/src/core/model/type-id.cc
--- ns-3.41/src/core/model/type-id.cc	2024-02-09 14:44:07.889790000 -0800
+++ ns-3.42/src/core/model/type-id.cc	2024-05-29 15:29:46.936073000 -0700
@@ -457,7 +457,8 @@
 IidManager::LookupInformation(uint16_t uid) const
 {
     NS_LOG_FUNCTION(IID << uid);
-    NS_ASSERT(uid <= m_information.size() && uid != 0);
+    NS_ASSERT_MSG(uid <= m_information.size() && uid != 0,
+                  "The uid " << uid << " for this TypeId is invalid");
     NS_LOG_LOGIC(IIDL << m_information[uid - 1].name);
     return const_cast<IidInformation*>(&m_information[uid - 1]);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/unix-fd-reader.cc ns-3.42/src/core/model/unix-fd-reader.cc
--- ns-3.41/src/core/model/unix-fd-reader.cc	2024-02-09 14:44:07.889790000 -0800
+++ ns-3.42/src/core/model/unix-fd-reader.cc	2024-05-29 15:29:46.936073000 -0700
@@ -93,7 +93,7 @@
     // scheduling a "destroy time" method to make sure the thread exits before
     // proceeding.
     //
-    if (!m_destroyEvent.IsRunning())
+    if (!m_destroyEvent.IsPending())
     {
         // hold a reference to ensure that this object is not
         // deallocated before the destroy-time event fires
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/val-array.h ns-3.42/src/core/model/val-array.h
--- ns-3.41/src/core/model/val-array.h	2024-02-09 14:44:07.889790000 -0800
+++ ns-3.42/src/core/model/val-array.h	2024-05-29 15:29:46.936073000 -0700
@@ -30,6 +30,11 @@
 {
 
 /**
+ * \defgroup Matrices Classes to do efficient math operations on arrays
+ * \ingroup core
+ */
+
+/**
  * \ingroup Matrices
  *
  * \brief ValArray is a class to efficiently store 3D array. The class is general
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/vector.cc ns-3.42/src/core/model/vector.cc
--- ns-3.41/src/core/model/vector.cc	2024-02-09 14:44:07.889790000 -0800
+++ ns-3.42/src/core/model/vector.cc	2024-05-29 15:29:46.936073000 -0700
@@ -27,7 +27,7 @@
 
 /**
  * \file
- * \ingroup attribute_Vector
+ * \ingroup geometry
  * ns3::Vector, ns3::Vector2D and ns3::Vector3D attribute value implementations.
  */
 
@@ -201,6 +201,24 @@
     return Vector3D(a.x - b.x, a.y - b.y, a.z - b.z);
 }
 
+Vector3D
+operator*(const Vector3D& a, double b)
+{
+    return Vector3D(a.x * b, a.y * b, a.z * b);
+}
+
+Vector3D
+operator*(double a, const Vector3D& b)
+{
+    return Vector3D(b.x * a, b.y * a, b.z * a);
+}
+
+double
+operator*(const Vector3D& a, const Vector3D& b)
+{
+    return a.x * b.x + a.y * b.y + a.z * b.z;
+}
+
 std::ostream&
 operator<<(std::ostream& os, const Vector2D& vector)
 {
@@ -268,4 +286,22 @@
     return Vector2D(a.x - b.x, a.y - b.y);
 }
 
+Vector2D
+operator*(const Vector2D& a, double b)
+{
+    return Vector2D(a.x * b, a.y * b);
+}
+
+Vector2D
+operator*(double a, const Vector2D& b)
+{
+    return Vector2D(b.x * a, b.y * a);
+}
+
+double
+operator*(const Vector2D& a, const Vector2D& b)
+{
+    return a.x * b.x + a.y * b.y;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/vector.h ns-3.42/src/core/model/vector.h
--- ns-3.41/src/core/model/vector.h	2024-02-09 14:44:07.889790000 -0800
+++ ns-3.42/src/core/model/vector.h	2024-05-29 15:29:46.936073000 -0700
@@ -172,6 +172,30 @@
      * \returns The vector difference of \pname{a} and \pname{b}.
      */
     friend Vector3D operator-(const Vector3D& a, const Vector3D& b);
+
+    /**
+     * Scalar multiplication operator.
+     * \param [in] a lhs vector.
+     * \param [in] b rhs scalar.
+     * \returns The vector \pname{a} scaled by \pname{b}.
+     */
+    friend Vector3D operator*(const Vector3D& a, double b);
+
+    /**
+     * Scalar multiplication operator.
+     * \param [in] a lhs scalar.
+     * \param [in] b rhs vector.
+     * \returns The vector \pname{b} scaled by \pname{a}.
+     */
+    friend Vector3D operator*(double a, const Vector3D& b);
+
+    /**
+     * Dot product operator.
+     * \param [in] a lhs vector.
+     * \param [in] b rhs vector.
+     * \returns The dot product of \pname{a} and \pname{b}.
+     */
+    friend double operator*(const Vector3D& a, const Vector3D& b);
 };
 
 /**
@@ -301,6 +325,30 @@
      * \returns The vector difference of \pname{a} and \pname{b}.
      */
     friend Vector2D operator-(const Vector2D& a, const Vector2D& b);
+
+    /**
+     * Scalar multiplication operator.
+     * \param [in] a lhs vector.
+     * \param [in] b rhs scalar.
+     * \returns The vector \pname{a} scaled by \pname{b}.
+     */
+    friend Vector2D operator*(const Vector2D& a, double b);
+
+    /**
+     * Scalar multiplication operator.
+     * \param [in] a lhs scalar.
+     * \param [in] b rhs vector.
+     * \returns The vector \pname{b} scaled by \pname{a}.
+     */
+    friend Vector2D operator*(double a, const Vector2D& b);
+
+    /**
+     * Dot product operator.
+     * \param [in] a lhs vector.
+     * \param [in] b rhs vector.
+     * \returns The dot product of \pname{a} and \pname{b}.
+     */
+    friend double operator*(const Vector2D& a, const Vector2D& b);
 };
 
 double CalculateDistance(const Vector3D& a, const Vector3D& b);
@@ -318,47 +366,53 @@
 ATTRIBUTE_HELPER_HEADER(Vector2D);
 
 /**
+ * \ingroup attribute_Vector3D
  * \relates Vector3D
  * Vector alias typedef for compatibility with mobility models
  */
 typedef Vector3D Vector;
 
 /**
+ * \ingroup attribute_Vector3D
  * \relates Vector3D
  * Vector alias typedef for compatibility with mobility models
  */
 typedef Vector3DValue VectorValue;
 
 /**
+ * \ingroup attribute_Vector3D
  * \relates Vector3D
  * Vector alias typedef for compatibility with mobility models
  */
 typedef Vector3DChecker VectorChecker;
 
-// Document these by hand so they go in group attribute_Vector3D
-/**
- * \relates Vector3D
- * \fn ns3::Ptr<const ns3::AttributeAccessor> ns3::MakeVectorAccessor (T1 a1)
- * \copydoc ns3::MakeAccessorHelper(T1)
- * \see AttributeAccessor
- */
-
-/**
- * \relates Vector3D
- * \fn ns3::Ptr<const ns3::AttributeAccessor> ns3::MakeVectorAccessor (T1 a1, T2 a2)
- * \copydoc ns3::MakeAccessorHelper(T1,T2)
- * \see AttributeAccessor
- */
-
 ATTRIBUTE_ACCESSOR_DEFINE(Vector);
 
-/**
- * \relates Vector3D
- * \returns The AttributeChecker.
- * \see AttributeChecker
- */
 Ptr<const AttributeChecker> MakeVectorChecker();
 
 } // namespace ns3
 
+// Document these by hand so they go in group attribute_Vector3D
+
+/*!
+\ingroup attribute_Vector3D
+\fn ns3::Ptr<const ns3::AttributeAccessor> ns3::MakeVectorAccessor (T1 a1)
+\copydoc ns3::MakeAccessorHelper(T1)
+\see AttributeAccessor
+*/
+
+/*!
+\ingroup attribute_Vector3D
+\fn ns3::Ptr<const ns3::AttributeAccessor> ns3::MakeVectorAccessor (T1 a1, T2 a2)
+\copydoc ns3::MakeAccessorHelper(T1,T2)
+\see AttributeAccessor
+*/
+
+/*!
+\ingroup attribute_Vector3D
+\fn ns3::Ptr<const ns3::AttributeChecker> ns3::MakeVectorChecker ()
+\returns The AttributeChecker.
+\see AttributeChecker
+*/
+
 #endif /* NS3_VECTOR_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/version.cache ns-3.42/src/core/model/version.cache
--- ns-3.41/src/core/model/version.cache	2024-02-09 14:46:04.290617700 -0800
+++ ns-3.42/src/core/model/version.cache	2024-05-29 15:30:10.908134200 -0700
@@ -1,10 +1,10 @@
-CLOSEST_TAG = '"ns-3.41"'
-VERSION_COMMIT_HASH = '"ge5039092b"'
+CLOSEST_TAG = '"ns-3.42"'
+VERSION_COMMIT_HASH = '"gab4cce021"'
 VERSION_DIRTY_FLAG = '0'
 VERSION_MAJOR = '3'
-VERSION_MINOR = '41'
+VERSION_MINOR = '42'
 VERSION_PATCH = '0'
 VERSION_RELEASE_CANDIDATE = '""'
-VERSION_TAG = '"ns-3.41"'
+VERSION_TAG = '"ns-3.42"'
 VERSION_TAG_DISTANCE = '0'
 VERSION_BUILD_PROFILE = 'default'
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/warnings.h ns-3.42/src/core/model/warnings.h
--- ns-3.41/src/core/model/warnings.h	2024-02-09 14:44:07.889790000 -0800
+++ ns-3.42/src/core/model/warnings.h	2024-05-29 15:29:46.940073000 -0700
@@ -21,28 +21,42 @@
 #define NS3_WARNINGS_H
 
 /**
+ * \defgroup warnings Compiler warnings
  * \ingroup core
+ *
+ * Macros useful to silence compiler warnings on selected code parts.
+ */
+
+/**
+ * \ingroup warnings
  * \def NS_WARNING_POP
  * Pops the diagnostic warning list from the stack, restoring it to the previous state.
  * \sa NS_WARNING_PUSH
  */
 
 /**
- * \ingroup core
+ * \ingroup warnings
  * \def NS_WARNING_PUSH
  * Push the diagnostic warning list to the stack, allowing it to be restored later.
  * \sa NS_WARNING_POP
  */
 
 /**
- * \ingroup core
+ * \ingroup warnings
  * \def NS_WARNING_SILENCE_DEPRECATED
  * Silences the "-Wdeprecated-declarations" warnings.
  * \sa NS_WARNING_POP
  */
 
 /**
- * \ingroup core
+ * \ingroup warnings
+ * \def NS_WARNING_SILENCE_MAYBE_UNINITIALIZED
+ * Silences GCC "-Wmaybe-uninitialized" warnings.
+ * \sa NS_WARNING_POP
+ */
+
+/**
+ * \ingroup warnings
  * \def NS_WARNING_PUSH_DEPRECATED
  * Save the current warning list and disables the ones about deprecated functions and classes.
  *
@@ -55,9 +69,30 @@
  *   NS_WARNING_POP;
  * \endcode
  *
+ * This macro is equivalent to
+ * \code
+ *   NS_WARNING_PUSH;
+ *   NS_WARNING_SILENCE_DEPRECATED;
+ * \endcode
+ *
  * Its use is, of course, not suggested unless strictly necessary.
  */
 
+/**
+ * \ingroup warnings
+ * \def NS_WARNING_PUSH_MAYBE_UNINITIALIZED
+ * Save the current warning list and disables the ones about possible uninitialized variables.
+ *
+ *
+ * This macro is equivalent to
+ * \code
+ *   NS_WARNING_PUSH;
+ *   NS_WARNING_SILENCE_MAYBE_UNINITIALIZED;
+ * \endcode
+ *
+ * \sa NS_WARNING_PUSH_DEPRECATED
+ */
+
 #if defined(_MSC_VER)
 // You can find the MSC warning codes at
 // https://learn.microsoft.com/en-us/cpp/error-messages/compiler-warnings/compiler-warnings-c4000-c5999
@@ -79,8 +114,20 @@
 
 #endif
 
+// GCC-specific - Apple's clang pretends to be both...
+#if defined(__GNUC__) && !defined(__clang__)
+#define NS_WARNING_SILENCE_MAYBE_UNINITIALIZED                                                     \
+    _Pragma("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
+#else
+#define NS_WARNING_SILENCE_MAYBE_UNINITIALIZED
+#endif
+
 #define NS_WARNING_PUSH_DEPRECATED                                                                 \
     NS_WARNING_PUSH;                                                                               \
     NS_WARNING_SILENCE_DEPRECATED
 
+#define NS_WARNING_PUSH_MAYBE_UNINITIALIZED                                                        \
+    NS_WARNING_PUSH;                                                                               \
+    NS_WARNING_SILENCE_MAYBE_UNINITIALIZED
+
 #endif /* NS3_WARNINGS_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/watchdog.cc ns-3.42/src/core/model/watchdog.cc
--- ns-3.41/src/core/model/watchdog.cc	2024-02-09 14:44:07.889790000 -0800
+++ ns-3.42/src/core/model/watchdog.cc	2024-05-29 15:29:46.940073000 -0700
@@ -52,7 +52,7 @@
     NS_LOG_FUNCTION(this << delay);
     Time end = Simulator::Now() + delay;
     m_end = std::max(m_end, end);
-    if (m_event.IsRunning())
+    if (m_event.IsPending())
     {
         return;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/watchdog.h ns-3.42/src/core/model/watchdog.h
--- ns-3.41/src/core/model/watchdog.h	2024-02-09 14:44:07.889790000 -0800
+++ ns-3.42/src/core/model/watchdog.h	2024-05-29 15:29:46.940073000 -0700
@@ -31,8 +31,13 @@
 namespace ns3
 {
 
+namespace internal
+{
+
 class TimerImpl;
 
+} // namespace internal
+
 /**
  * \ingroup timer
  * \brief A very simple watchdog operating in virtual time.
@@ -115,7 +120,7 @@
      * The timer implementation, which contains the bound callback
      * function and arguments.
      */
-    TimerImpl* m_impl;
+    internal::TimerImpl* m_impl;
     /** The future event scheduled to expire the timer. */
     EventId m_event;
     /** The absolute time when the timer will expire. */
@@ -138,7 +143,7 @@
 Watchdog::SetFunction(FN fn)
 {
     delete m_impl;
-    m_impl = MakeTimerImpl(fn);
+    m_impl = internal::MakeTimerImpl(fn);
 }
 
 template <typename MEM_PTR, typename OBJ_PTR>
@@ -146,7 +151,7 @@
 Watchdog::SetFunction(MEM_PTR memPtr, OBJ_PTR objPtr)
 {
     delete m_impl;
-    m_impl = MakeTimerImpl(memPtr, objPtr);
+    m_impl = internal::MakeTimerImpl(memPtr, objPtr);
 }
 
 template <typename... Ts>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/win32-fd-reader.cc ns-3.42/src/core/model/win32-fd-reader.cc
--- ns-3.41/src/core/model/win32-fd-reader.cc	2024-02-09 14:44:07.889790000 -0800
+++ ns-3.42/src/core/model/win32-fd-reader.cc	2024-05-29 15:29:46.940073000 -0700
@@ -41,7 +41,10 @@
 
 NS_LOG_COMPONENT_DEFINE("FdReader");
 
+// conditional compilation to avoid Doxygen errors
+#ifdef __WIN32__
 bool FdReader::winsock_initialized = false;
+#endif
 
 FdReader::FdReader()
     : m_fd(-1),
@@ -101,7 +104,7 @@
     // scheduling a "destroy time" method to make sure the thread exits before
     // proceeding.
     //
-    if (!m_destroyEvent.IsRunning())
+    if (!m_destroyEvent.IsPending())
     {
         // hold a reference to ensure that this object is not
         // deallocated before the destroy-time event fires
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/attribute-container-test-suite.cc ns-3.42/src/core/test/attribute-container-test-suite.cc
--- ns-3.41/src/core/test/attribute-container-test-suite.cc	2024-02-09 14:44:07.889790000 -0800
+++ ns-3.42/src/core/test/attribute-container-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -196,22 +196,6 @@
 /**
  * \ingroup attribute-tests
  *
- * This function handles mixed constness and compatible, yet
- * distinct numerical classes (like int and long)
- * \param x The left operand.
- * \param y The right operand.
- * \return true if the pairs have the same numerical values.
- */
-template <class A, class B, class C, class D>
-bool
-operator==(const std::pair<A, B>& x, const std::pair<C, D>& y)
-{
-    return x.first == y.first && x.second == y.second;
-}
-
-/**
- * \ingroup attribute-tests
- *
  * Test AttributeContainer instantiation, initialization, access
  */
 class AttributeContainerTestCase : public TestCase
@@ -307,7 +291,9 @@
         for (const auto& v : ref)
         {
             NS_TEST_ASSERT_MSG_NE(true, (aciter == ac.End()), "AC iterator reached end");
-            NS_TEST_ASSERT_MSG_EQ(v, (*aciter)->Get(), "Incorrect value");
+            bool valCheck =
+                v.first == (*aciter)->Get().first && v.second == (*aciter)->Get().second;
+            NS_TEST_ASSERT_MSG_EQ(valCheck, true, "Incorrect value");
             ++aciter;
         }
         NS_TEST_ASSERT_MSG_EQ(true, (aciter == ac.End()), "AC iterator did not reach end");
@@ -542,7 +528,8 @@
         auto iter = map.begin();
         for (const auto& v : mapstrint)
         {
-            NS_TEST_ASSERT_MSG_EQ(v, *iter, "Incorrect value in mapstrint");
+            bool valCheck = v.first == (*iter).first && v.second == (*iter).second;
+            NS_TEST_ASSERT_MSG_EQ(valCheck, true, "Incorrect value in mapstrint");
             ++iter;
         }
     }
@@ -560,11 +547,11 @@
 };
 
 AttributeContainerTestSuite::AttributeContainerTestSuite()
-    : TestSuite("attribute-container-test-suite", UNIT)
+    : TestSuite("attribute-container-test-suite", Type::UNIT)
 {
-    AddTestCase(new AttributeContainerTestCase(), TestCase::QUICK);
-    AddTestCase(new AttributeContainerSerializationTestCase(), TestCase::QUICK);
-    AddTestCase(new AttributeContainerSetGetTestCase(), TestCase::QUICK);
+    AddTestCase(new AttributeContainerTestCase(), TestCase::Duration::QUICK);
+    AddTestCase(new AttributeContainerSerializationTestCase(), TestCase::Duration::QUICK);
+    AddTestCase(new AttributeContainerSetGetTestCase(), TestCase::Duration::QUICK);
 }
 
 static AttributeContainerTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/attribute-test-suite.cc ns-3.42/src/core/test/attribute-test-suite.cc
--- ns-3.41/src/core/test/attribute-test-suite.cc	2024-02-09 14:44:07.889790000 -0800
+++ ns-3.42/src/core/test/attribute-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -2084,44 +2084,44 @@
 };
 
 AttributesTestSuite::AttributesTestSuite()
-    : TestSuite("attributes", UNIT)
+    : TestSuite("attributes", Type::UNIT)
 {
     AddTestCase(new AttributeTestCase<BooleanValue>("Check Attributes of type BooleanValue"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new AttributeTestCase<IntegerValue>("Check Attributes of type IntegerValue"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new AttributeTestCase<UintegerValue>("Check Attributes of type UintegerValue"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new AttributeTestCase<DoubleValue>("Check Attributes of type DoubleValue"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new AttributeTestCase<EnumValue<AttributeObjectTest::Test_e>>(
                     "Check Attributes of type EnumValue"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new AttributeTestCase<EnumValue<AttributeObjectTest::Test_ec>>(
                     "Check Attributes of type EnumValue (wrapping an enum class)"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new AttributeTestCase<TimeValue>("Check Attributes of type TimeValue"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(
         new RandomVariableStreamAttributeTestCase("Check Attributes of type RandomVariableStream"),
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
     AddTestCase(new ObjectVectorAttributeTestCase("Check Attributes of type ObjectVectorValue"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new ObjectMapAttributeTestCase("Check Attributes of type ObjectMapValue"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new PointerAttributeTestCase("Check Attributes of type PointerValue"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new CallbackValueTestCase("Check Attributes of type CallbackValue"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(new IntegerTraceSourceAttributeTestCase(
                     "Ensure TracedValue<uint8_t> can be set like IntegerValue"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
     AddTestCase(
         new IntegerTraceSourceTestCase("Ensure TracedValue<uint8_t> also works as trace source"),
-        TestCase::QUICK);
+        TestCase::Duration::QUICK);
     AddTestCase(new TracedCallbackTestCase(
                     "Ensure TracedCallback<double, int, float> works as trace source"),
-                TestCase::QUICK);
+                TestCase::Duration::QUICK);
 }
 
 static AttributesTestSuite g_attributesTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/callback-test-suite.cc ns-3.42/src/core/test/callback-test-suite.cc
--- ns-3.41/src/core/test/callback-test-suite.cc	2024-02-09 14:44:07.889790000 -0800
+++ ns-3.42/src/core/test/callback-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -1190,14 +1190,14 @@
 };
 
 CallbackTestSuite::CallbackTestSuite()
-    : TestSuite("callback", UNIT)
+    : TestSuite("callback", Type::UNIT)
 {
-    AddTestCase(new BasicCallbackTestCase, TestCase::QUICK);
-    AddTestCase(new MakeCallbackTestCase, TestCase::QUICK);
-    AddTestCase(new MakeBoundCallbackTestCase, TestCase::QUICK);
-    AddTestCase(new CallbackEqualityTestCase, TestCase::QUICK);
-    AddTestCase(new NullifyCallbackTestCase, TestCase::QUICK);
-    AddTestCase(new MakeCallbackTemplatesTestCase, TestCase::QUICK);
+    AddTestCase(new BasicCallbackTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new MakeCallbackTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new MakeBoundCallbackTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new CallbackEqualityTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new NullifyCallbackTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new MakeCallbackTemplatesTestCase, TestCase::Duration::QUICK);
 }
 
 static CallbackTestSuite g_gallbackTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/event-garbage-collector-test-suite.cc ns-3.42/src/core/test/event-garbage-collector-test-suite.cc
--- ns-3.41/src/core/test/event-garbage-collector-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/event-garbage-collector-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -24,7 +24,7 @@
  * \file
  * \ingroup core-tests
  * \ingroup events
- * \ingroup events-garbage-tests
+ * \ingroup event-garbage-tests
  * EventGarbageCollector test suite.
  */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/examples-as-tests-test-suite.cc ns-3.42/src/core/test/examples-as-tests-test-suite.cc
--- ns-3.41/src/core/test/examples-as-tests-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/examples-as-tests-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -32,6 +32,7 @@
 
 /**
  * \ingroup core-tests
+ * \ingroup testing
  * \defgroup examples-as-tests Examples as tests test suite
  *
  * Runs several examples as tests in order to test ExampleAsTestSuite and ExampleAsTestCase.
@@ -101,7 +102,7 @@
 };
 
 ExamplesAsTestsTestSuite::ExamplesAsTestsTestSuite()
-    : TestSuite("examples-as-tests-test-suite", UNIT)
+    : TestSuite("examples-as-tests-test-suite", Type::UNIT)
 {
     AddTestCase(
         new ExampleAsTestCase("core-example-simulator", "sample-simulator", NS_TEST_SOURCEDIR));
@@ -114,14 +115,14 @@
 }
 
 /**
- * \ingroup examples-tests
+ * \ingroup examples-as-tests
  * ExampleAsTestsTestSuite instance variable.
  * Tests multiple examples in a single TestSuite using AddTestCase to add the examples to the suite.
  */
 static ExamplesAsTestsTestSuite g_examplesAsTestsTestSuite;
 
 /**
- * \ingroup examples-tests
+ * \ingroup examples-as-tests
  * ExampleTestSuite instance variables.
  *
  * Tests ExampleTestSuite which runs a single example as test suite as specified in constructor
